' COMAL - COM Access Library. COMAL (Pronounced COM UL).
'
' comal.dll is a Dynamic Linked Library written by me,
' John White <yoingco@btinternet.com>, for myself and
' any programming language that can utilize it.

$OPTIMIZE ON
$APPTYPE GUI
$TYPECHECK ON
$ESCAPECHARS ON
$INCLUDE "comal.inc"

DIM form AS QFORM
DIM B1 AS QBUTTON, B2 AS QBUTTON, B3 AS QBUTTON
DIM xlrtn AS BYTE
DIM vle AS DOUBLE
DIM rtn AS INTEGER
DIM stg$ AS STRING

xlrtn=FALSE

SUB CleanUp_Word
IF xlrtn=TRUE THEN
XDOCUMENT_Close
xlrtn=FALSE
END IF
END SUB

SUB BC1(Sender AS QBUTTON)
xlrtn=XDOCUMENT_Open
if xlrtn=TRUE THEN

EXCEL_FullScreen(NO)

XSHEET_SetName("Business Accounts")
rtn=XSHEET_GetName
stg$=VarPtr$(rtn)
'ShowMessage("Excel Sheet Name: "+stg$)

XCELL_WriteText(10,2,"Bread")
XCELL_WriteText(11,2,"Milk")
XCELL_WriteText(12,2,"Sugar")

' see the Format->Cells menu.
XCELL_SetColour("D3:E7",&H000000FF)
XCELL_SetBorderColour("D3:E7",&H0000FFFF)
' 1 to 13.
XCELL_SetBorderStyle("D3:E7",13)
' 1 to 4. See weight property->border->xlBorderWeight
XCELL_SetBorderThickness("D3:E7",4)
' 0 to 18.
XCELL_SetPattern("D3:E7",18)
' Set the Cell (Font / Column Height) Size.
XCELL_SetFontSize("D3:E7",44)

XCELL_WriteValue("B2:B4",23)
XCELL_WriteValue("B6",32)

XCELL_MergeCells("B15:E15")
XCELL_WriteMergedText("B15","This text is inside Merged Cells.")
' Range, lineStyle, Thickness, Colour.
XCELL_AddBorder("B15:E15",13,4,&H00FF00FF)

XCELL_SetColumnWidth("A:E",6.57)

'Sleep 2
'vle=XCELL_ReadValue("B2:B2")
'showmessage("Value of Cell B2: "+Str$(vle))

'rtn=XCELL_ReadText("B11")
'stg$=VarPtr$(rtn)
'ShowMessage("Text of Cell B11: "+stg$)

' Clear the Bread/Milk/Sugar cells above.
'XCELL_ClearRange("B10:B12")

XSHEET_ActivateByNumber(2)
XSHEET_SetName("Home Accounts")
XCELL_CopySourceToDest("Business Accounts","B10:B12","Home Accounts","A1:A3")

'XSHEET_ActivateByNumber(1)
'XSHEET_ActivateByName("Sheet1")
XSHEET_ActivateByName("Business Accounts")

XCELL_SelectRange("B10:B12")
XCELL_CopyRangeToClipboard("B10:B12")
XCELL_PasteRangeFromClipboard("Business Accounts","D10:D12")
XCELL_PasteRangeFromClipboard("Business Accounts","F10:F12")

END IF
END SUB

SUB BC2(Sender AS QBUTTON)
XSHEET_PrintActiveSheet
END SUB

SUB BC3(Sender AS QBUTTON)
' Print to a (.prn) File
'EXCEL_PrintAll(1,NO,"",YES,YES,"C:\\Test.prn")
' Print to a particular Printer
'EXCEL_PrintAll(1,NO,"EPSON Stylus C44 Series on NE01",NO,YES,"")
' Print to the Default printer
EXCEL_PrintAll(1,NO,"",NO,YES,"")
END SUB

Form.Width=400
Form.Height=76
Form.Center
Form.Caption="COMAL - COM Access Library."
Form.OnClose=CleanUp_Word

B1.Parent=Form
B1.Caption="Excel Example"
B1.Top=6
B1.Left=6
B1.Width=100
B1.Height=30
B1.OnClick=BC1

B2.Parent=Form
B2.Caption="Print ActiveSheet"
B2.Top=6
B2.Left=126
B2.Width=120
B2.Height=30
B2.OnClick=BC2

B3.Parent=Form
B3.Caption="Print All"
B3.Top=6
B3.Left=266
B3.Width=100
B3.Height=30
B3.OnClick=BC3

Form.ShowModal
